#! /usr/bin/perl -w
use FileHandle;

# temp.ra  temp.snd Ѵץࡣ
# Ķˤ碌ƽƤ
# for ogg
# my $convert_program = 'vsound -t -f temp.wav trplayer temp.ra > /dev/null && oggenc -Q temp.wav -o temp.snd && rm temp.wav';
# for mp3
my $convert_program = 'vsound -t -f temp.wav trplayer temp.ra > /dev/null && lame --silent temp.wav temp.snd && rm temp.wav';

my $source_directory = shift;

my $main_file_name = exist_check('DATA/main.txt');
my $handle = FileHandle->new();
if (!$handle->open("$main_file_name", 'r')) {
  die "failed to open the file: $main_file_name\n";
}
# ӥåȿžԥ (\x100-\x0a) ǹԤʬ롣
$/ = "\xf5";
binmode $handle;

my $snd_file_name = exist_check('DATA/srdra.bnd');
my $handle_in = FileHandle->new();
if (!$handle_in->open("$snd_file_name", 'r')) {
  die "failed to open the file: $snd_file_name\n";
}
binmode $handle_in;

my %count = ();
my $new_offset = 0;
my $loop = 1;
while ($_ = ~ $handle->getline) {
  if (/^SND=([0-9a-f]{8}),([0-9a-f]{4})$/) {
    my $offset_hex = $1;
    my $length_hex = $2;
    next if ($length_hex eq '0000');

    # ʣФν
    next if (defined $count{$offset_hex});
    $count{$offset_hex}=1;
    print STDERR "$loop: $offset_hex $length_hex\n";
    $loop++;
    my $offset = hex $offset_hex;
    my $length = hex $length_hex;
    my $handle_out = FileHandle->new();
    if (!$handle_out->open("temp.ra", 'w')) {
      die "failed to open the file: temp.ra\n";
    }
    binmode $handle_out;
    seek($handle_in, $offset, 0) || die "Seek Error\n";
    read $handle_in, my $content, $length || die "Read Error\n";
    print $handle_out $content || die "Write Error\n";
    $handle_out->close();
    system $convert_program;
    system "cat temp.snd >> srdra.bnd";
    my $new_length = -s 'temp.snd';
    printf("%s %s %08x %04x\n", $offset_hex, $length_hex,
	   $new_offset, $new_length);
    $new_offset += $new_length;
  }
}

#
# ե뤬뤫ǧ
# ʸʸǧ¸ߤե֤̾
#
sub exist_check {
  my($in) = $_[0];
  my($out) = $in;
  return "$source_directory/$out" if -f "$source_directory/$out";
  $out = lc($out);
  return "$source_directory/$out" if -f "$source_directory/$out";
  $out = uc($out);
  return "$source_directory/$out" if -f "$source_directory/$out";
  die "file not found: $in\n"
}
